{
Accepts the body of a psp component and pulls out :
1) Public methods that are listed in the header
2) private methods that are listed in the body, but not in the header

calls PPVars to attain the vars list.

<METHOD NAME="" PARAMETERS="" RETURN="[empty for procedure, type if functional]">
  <VAR>  </VAR>
..htmlcontent
<%
..code
%>
..htmlcontent
</METHOD>

* I removed the VARPARAMETERS because I think the RPC mechanism will be intelligent and
specific enough to handle that... so you just declare:
PARAMETERS="x:integer;VAR allow:boolean;"
}
unit preprocessmethods;    
interface
uses classes,sysutils,lowx,preprocessvars,preprocessexecutable;

function processMethodVars (data:String):String;
function produceMethodsIMplementation(classname:String;data:String):String;
function processSingleMethodDeclaration (classname:String;MethodTag:String):String;
function produceMethodsPublicdeclaration (Data:String):String;

implementation

function processMethodVars (data:String):String;
begin
 result:=producevarstatement(data);
end;

function processMethodsImplementation(classname:String;MethodList:tstringlist):String;
var i:integer; outhold,mVars,mbody:String;
begin
 for i:= 0 to Methodlist.count-1 do
  begin
{Show the declaration}
// writeln('Declare');
   outhold:=outhold + processSingleMethodDeclaration (classname,Methodlist[i]) + #13+#10;

{insert any vars}
 //writeln('Vars');
   mVars:= processMethodVars(Methodlist[i]);
   if trim(mVars) <>'' then outhold:=outhold+ mVars;

{preprocess and build the begin..end and body code}
 //writeln('TagData');
   mbody:=GetTagData (Methodlist[i],'METHOD');
 
   outhold:= outhold+'begin'+#13+#10;
   
   outhold:=outhold + produceExecutableStatement(mbody,NO_DEBUG)+#13+#10; 
   outhold:= outhold+'end;'+#13+#10+#13+#10;
 {rinse and repeat for all the methods in this class!}
  end;
 //writeln('Done');
result:=outhold;
end;

function processSingleMethodDeclaration (classname:String;MethodTag:String):String;
var outhold,hold,mName,mParams,mReturn,mProc,mOvr,mParen,mFuncResult:String;
begin
 hold:=MethodTag;
 mName := GetTagProperty (hold,'METHOD','NAME');
 {Be nice and accept either way}
 mParams := GetTagProperty (hold,'METHOD','PARAMETERS');
 mParams  := mParams + GetTagProperty (hold,'METHOD','PARAMS');
 mReturn := GetTagProperty (hold,'METHOD','RETURN');
 mProc:='procedure';
 mFuncresult:='';
 if trim(mReturn)<>'' then 
 		begin
		 mProc:='function';
		 mFuncResult:=':'+ mReturn;
		end;
 outhold:= mProc+' ';
 if classname<>'' then outhold:=outhold+classname+'.'  ;
 mOvr:='';
 {If we are not processing the implementation, THEN we need  to declare the override}
 if classname='' then 
  begin
     if Uppercase(mName) ='ONCREATE' then mOvr:='override;';
     if Uppercase(mName) ='ONDESTROY' then mOvr:='override;';
     if Uppercase(mName) ='ONEXECUTE' then mOvr:='override;';
     if Uppercase(mName) ='ONSTART' then mOvr:='override;';
     if Uppercase(mName) ='ONSTOP' then mOvr:='override;';
     if Uppercase(mName) ='ONPAUSE' then mOvr:='override;';
     if Uppercase(mName) ='ONRESUME' then mOvr:='override;';
   end;
 if mParams<>'' then mParen:='('+mParams+')' ;
 outhold:=outhold+ mName+ mParen + mfuncresult + ';' +mOvr;
 result:=outhold;
end;

function processMethodsPublicdeclaration (MethodList:tstringlist):String;
 
 {accepts a list of Methods and produces the public declaration
  [procedure|function] [classname].[MethodName] [([Parameters])] [:Return];
 }
 var i:integer; outhold:String;
begin
 for i:= 0 to Methodlist.count-1 do
  begin
   outhold:=outhold + '   ' + processSingleMethodDeclaration ('',Methodlist[i]) + #13+#10;
  end;
result:=outhold;
end;

function produceMethodsPublicdeclaration(Data:String):String;
var ml:TStringlist;
begin
ml:=GetTagList(data,'METHOD');
result:=processMethodsPublicdeclaration(ml);
end;

function produceMethodsIMplementation(classname:String;data:String):String;
var ml:tstringlist;outhold:string;
begin
ml:=gettaglist(data,'METHOD');
result:='';
if assigned(ml) then
begin
 result:= processMethodsImplementation(classname,ml);
 if assigned(ml) then
 begin
   ml.clear;
   ml.free;
 end;
end;
end;

end.
